//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    20:40:13 03/04/2008 
// Design Name: 
// Module Name:    bias_update 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module bias_update(nn_out, expected, bias_old, bias_new);
    input nn_out;
    input expected;
 
    input [7:0] bias_old;
    output [7:0] bias_new;

 	 wire cout;
	 wire [7:0] diff;
	 
    error_diff errorDiff(nn_out, expected, diff);
	 full_adder8 adder(diff, bias_old, 1'b0, bias_new, cout);
endmodule


