onerror {resume}
quietly WaveActivateNextPane {} 0
add wave -noupdate -format Logic Clk
add wave -noupdate -format Logic Reset
add wave -noupdate -format Logic In_Data_Exists
add wave -noupdate -format Logic In_FIFO_Read
add wave -noupdate -format Logic Out_FIFO_Full
add wave -noupdate -format Logic Out_FIFO_Write

add wave -noupdate -format Logic go
add wave -noupdate -format Logic done
add wave -noupdate -format Logic  nn_out
add wave -noupdate -format Logic  write
add wave -noupdate -format Logic  res

add wave -noupdate -format Logic read_1
add wave -noupdate -format Logic read_2
add wave -noupdate -format Logic read_3
add wave -noupdate -format Logic read_4

add wave -noupdate -format Literal -radix hexadecimal out_reg1
add wave -noupdate -format Literal -radix hexadecimal out_reg2
add wave -noupdate -format Literal -radix hexadecimal out_reg3
add wave -noupdate -format Literal -radix hexadecimal out_reg4

add wave -noupdate -format Literal -radix hexadecimal In_Data_FIFO
add wave -noupdate -format Literal -radix hexadecimal Out_Data_FIFO

add wave -noupdate -format Literal -radix hexadecimal current_state
add wave -noupdate -format Literal -radix hexadecimal counter
add wave -noupdate -format Literal -radix hexadecimal in_vector

add wave -noupdate -format Literal -radix hexadecimal sum





TreeUpdate [SetDefaultTree]
WaveRestoreCursors {{Cursor 1} {400 ns} 0}
WaveRestoreZoom {1023 ns} {2315 ns}
configure wave -namecolwidth 188
configure wave -valuecolwidth 40
configure wave -justifyvalue left
configure wave -signalnamewidth 0
configure wave -snapdistance 10
configure wave -datasetprefix 0
configure wave -rowmargin 4
configure wave -childrowmargin 2
configure wave -gridoffset 0
configure wave -gridperiod 1
configure wave -griddelta 40
configure wave -timeline 0
