//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    09:56:53 03/19/2008 
// Design Name: 
// Module Name:    Comparator 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module Comparator(in, out);

   parameter bus_width = 6'd16;
	parameter threshold = 16'd1014;
	
	input [bus_width-1:0] in;
   output out;
	
	wire [bus_width-1:0] adder_out;
	wire [bus_width-1:0] in_threshold;
   
	assign in_threshold = threshold;
	
	wire nothing;
	
	//subtract in from threshold to get a number. If this number is positive
	//then the pixel is black -> 0, else it is white -> 1
	full_adder16 adder_counter(~in, in_threshold, 1'b1, adder_out, nothing);
	
	assign out = adder_out[15];


endmodule
