library verilog;
use verilog.vl_types.all;
entity nn_interface is
    generic(
        C_DWIDTH        : integer := 32;
        st_reset        : integer := 0;
        st_read         : integer := 1;
        st_delay        : integer := 2;
        st_write        : integer := 3;
        st_go           : integer := 4;
        st_idle         : integer := 5;
        st_done         : integer := 6
    );
    port(
        Clk             : in     vl_logic;
        Reset           : in     vl_logic;
        In_Data_FIFO    : in     vl_logic_vector;
        In_Data_Exists  : in     vl_logic;
        In_FIFO_Read    : out    vl_logic;
        Out_Data_FIFO   : out    vl_logic_vector;
        Out_FIFO_Full   : in     vl_logic;
        Out_FIFO_Write  : out    vl_logic
    );
end nn_interface;
