//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    10:31:12 02/05/2008 
// Design Name: 
// Module Name:    full_adder16 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module full_adder16(X, Y, CIN, SUM, COUT);
    
	 input [15:0] X;
    input [15:0] Y;
    input CIN;
    output [15:0] SUM;
    output COUT;


	 wire [14:0] connect;
	 
	 full_adder adder0(X[0], Y[0], CIN, SUM[0], connect[0]);
	 full_adder adder1(X[1], Y[1], connect[0], SUM[1], connect[1]);
	 full_adder adder2(X[2], Y[2], connect[1], SUM[2], connect[2]);
	 full_adder adder3(X[3], Y[3], connect[2], SUM[3], connect[3]);
	 full_adder adder4(X[4], Y[4], connect[3], SUM[4], connect[4]);
	 full_adder adder5(X[5], Y[5], connect[4], SUM[5], connect[5]);
	 full_adder adder6(X[6], Y[6], connect[5], SUM[6], connect[6]);
	 full_adder adder7(X[7], Y[7], connect[6], SUM[7], connect[7]);
	 full_adder adder8(X[8], Y[8], connect[7], SUM[8], connect[8]);
	 full_adder adder9(X[9], Y[9], connect[8], SUM[9], connect[9]);
	 full_adder adder10(X[10], Y[10], connect[9], SUM[10], connect[10]);
	 full_adder adder11(X[11], Y[11], connect[10], SUM[11], connect[11]);
	 full_adder adder12(X[12], Y[12], connect[11], SUM[12], connect[12]);
	 full_adder adder13(X[13], Y[13], connect[12], SUM[13], connect[13]);
	 full_adder adder14(X[14], Y[14], connect[13], SUM[14], connect[14]);
	 full_adder adder15(X[15], Y[15], connect[14], SUM[15], COUT);


endmodule
