//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    12:57:10 02/26/2008 
// Design Name: 
// Module Name:    nn_accumulator 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module nn_accumulator(clk, enable, reset, in, out);
   
	parameter bus_width = 5'd16;
	parameter gnd = 1'b0; 
	
	input clk;
   input enable;
   input reset;
	input [bus_width-1:0] in;
   output [bus_width-1:0] out;
	
	wire [bus_width-1:0] adder_out;
	wire [bus_width-1:0] reg_out;
	wire [bus_width-1:0] in_one;
	wire nothing;
	
	
	
	nn_register_16 reg_counter(clk, adder_out, reset, enable, reg_out);
	full_adder16 adder_counter(reg_out, in, gnd, adder_out, nothing);
	
	assign out = reg_out;

endmodule
