//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    16:28:48 02/22/2008 
// Design Name: 
// Module Name:    nn_counter 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module nn_counter(clk, enable, reset, out);
   
	parameter bus_width = 5'd7;
	parameter one_val = 7'd1;
	parameter gnd = 1'b0; 
	
	input clk;
   input enable;
   input reset;
   output [bus_width-1:0] out;
	
	wire [bus_width-1:0] adder_out;
	wire [bus_width-1:0] reg_out;
	wire [bus_width-1:0] in_one;
	wire nothing;
	
	assign in_one = one_val;
	
	
	nn_register_7 reg_counter(clk, adder_out, reset, enable, reg_out);
	full_adder7 adder_counter(reg_out, in_one, gnd, adder_out, nothing);
	
	assign out = reg_out;

endmodule
