//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    13:26:10 02/27/2008 
// Design Name: 
// Module Name:    nn_testing 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module nn_testing(clk, expected, cont_enable, cont_reset, in_vector, nn_out);
		
		parameter weight_size = 4'd8;
		parameter input_size = 7'd99;
		parameter counter_size = 3'd7;
		parameter accumulator_size = 5'd16;
		
		input clk;
		input [2:0] cont_enable;
		input [2:0] cont_reset;
		input [input_size-1:0] in_vector;
		input expected;
		
		output nn_out;
		
		
		
		wire [weight_size-1:0] weight1;
		wire [weight_size-1:0] weight2;
		wire [weight_size-1:0] weight3;
		wire [weight_size-1:0] weight4;
		wire [weight_size-1:0] weight5;
		wire [weight_size-1:0] weight6;
		wire [weight_size-1:0] weight7;
		wire [weight_size-1:0] weight8;
		wire [weight_size-1:0] weight9;
		wire [weight_size-1:0] weight10;
		wire [weight_size-1:0] weight11;
		wire [weight_size-1:0] weight12;
		wire [weight_size-1:0] weight13;
		wire [weight_size-1:0] weight14;
		wire [weight_size-1:0] weight15;
		wire [weight_size-1:0] weight16;
		wire [weight_size-1:0] weight17;
		wire [weight_size-1:0] weight18;
		wire [weight_size-1:0] weight19;
		wire [weight_size-1:0] weight20;
		wire [weight_size-1:0] weight21;
		wire [weight_size-1:0] weight22;
		wire [weight_size-1:0] weight23;
		wire [weight_size-1:0] weight24;
		wire [weight_size-1:0] weight25;
		wire [weight_size-1:0] weight26;
		wire [weight_size-1:0] weight27;
		wire [weight_size-1:0] weight28;
		wire [weight_size-1:0] weight29;
		wire [weight_size-1:0] weight30;
		wire [weight_size-1:0] weight31;
		wire [weight_size-1:0] weight32;
		wire [weight_size-1:0] weight33;
		wire [weight_size-1:0] weight34;
		wire [weight_size-1:0] weight35;
		wire [weight_size-1:0] weight36;
		wire [weight_size-1:0] weight37;
		wire [weight_size-1:0] weight38;
		wire [weight_size-1:0] weight39;
		wire [weight_size-1:0] weight40;
		wire [weight_size-1:0] weight41;
		wire [weight_size-1:0] weight42;
		wire [weight_size-1:0] weight43;
		wire [weight_size-1:0] weight44;
		wire [weight_size-1:0] weight45;
		wire [weight_size-1:0] weight46;
		wire [weight_size-1:0] weight47;
		wire [weight_size-1:0] weight48;
		wire [weight_size-1:0] weight49;
		wire [weight_size-1:0] weight50;
		wire [weight_size-1:0] weight51;
		wire [weight_size-1:0] weight52;
		wire [weight_size-1:0] weight53;
		wire [weight_size-1:0] weight54;
		wire [weight_size-1:0] weight55;
		wire [weight_size-1:0] weight56;
		wire [weight_size-1:0] weight57;
		wire [weight_size-1:0] weight58;
		wire [weight_size-1:0] weight59;
		wire [weight_size-1:0] weight60;
		wire [weight_size-1:0] weight61;
		wire [weight_size-1:0] weight62;
		wire [weight_size-1:0] weight63;
		wire [weight_size-1:0] weight64;
		wire [weight_size-1:0] weight65;
		wire [weight_size-1:0] weight66;
		wire [weight_size-1:0] weight67;
		wire [weight_size-1:0] weight68;
		wire [weight_size-1:0] weight69;
		wire [weight_size-1:0] weight70;
		wire [weight_size-1:0] weight71;
		wire [weight_size-1:0] weight72;
		wire [weight_size-1:0] weight73;
		wire [weight_size-1:0] weight74;
		wire [weight_size-1:0] weight75;
		wire [weight_size-1:0] weight76;
		wire [weight_size-1:0] weight77;
		wire [weight_size-1:0] weight78;
		wire [weight_size-1:0] weight79;
		wire [weight_size-1:0] weight80;
		wire [weight_size-1:0] weight81;
		wire [weight_size-1:0] weight82;
		wire [weight_size-1:0] weight83;
		wire [weight_size-1:0] weight84;
		wire [weight_size-1:0] weight85;
		wire [weight_size-1:0] weight86;
		wire [weight_size-1:0] weight87;
		wire [weight_size-1:0] weight88;
		wire [weight_size-1:0] weight89;
		wire [weight_size-1:0] weight90;
		wire [weight_size-1:0] weight91;
		wire [weight_size-1:0] weight92;
		wire [weight_size-1:0] weight93;
		wire [weight_size-1:0] weight94;
		wire [weight_size-1:0] weight95;
		wire [weight_size-1:0] weight96;
		wire [weight_size-1:0] weight97;
		wire [weight_size-1:0] weight98;
		wire [weight_size-1:0] weight99;
		wire [weight_size-1:0] bias;
		
		
		wire [accumulator_size-1:0] result_out;
		wire [2:0] cont_reset;
		wire [2:0] cont_enable;
		wire [weight_size-1:0] s1_output1;
		wire [weight_size-1:0] s1_output2;
		wire [weight_size-1:0] s1_output3;
		wire [weight_size-1:0] s1_output4;
		wire [weight_size-1:0] s1_output5;
		wire [weight_size-1:0] s1_output6;
		wire [weight_size-1:0] s1_output7;
		wire [weight_size-1:0] s1_output8;
		wire [weight_size-1:0] s1_output9;
		wire [weight_size-1:0] s1_output10;
		wire [weight_size-1:0] s1_output11;
		wire [weight_size-1:0] s1_output12;
		wire [weight_size-1:0] s1_output13;
		wire [weight_size-1:0] s1_output14;
		wire [weight_size-1:0] s1_output15;
		wire [weight_size-1:0] s1_output16;
		wire [weight_size-1:0] s1_output17;
		wire [weight_size-1:0] s1_output18;
		wire [weight_size-1:0] s1_output19;
		wire [weight_size-1:0] s1_output20;
		wire [weight_size-1:0] s1_output21;
		wire [weight_size-1:0] s1_output22;
		wire [weight_size-1:0] s1_output23;
		wire [weight_size-1:0] s1_output24;
		wire [weight_size-1:0] s1_output25;
		wire [weight_size-1:0] s1_output26;
		wire [weight_size-1:0] s1_output27;
		wire [weight_size-1:0] s1_output28;
		wire [weight_size-1:0] s1_output29;
		wire [weight_size-1:0] s1_output30;
		wire [weight_size-1:0] s1_output31;
		wire [weight_size-1:0] s1_output32;
		wire [weight_size-1:0] s1_output33;
		wire [weight_size-1:0] s1_output34;
		wire [weight_size-1:0] s1_output35;
		wire [weight_size-1:0] s1_output36;
		wire [weight_size-1:0] s1_output37;
		wire [weight_size-1:0] s1_output38;
		wire [weight_size-1:0] s1_output39;
		wire [weight_size-1:0] s1_output40;
		wire [weight_size-1:0] s1_output41;
		wire [weight_size-1:0] s1_output42;
		wire [weight_size-1:0] s1_output43;
		wire [weight_size-1:0] s1_output44;
		wire [weight_size-1:0] s1_output45;
		wire [weight_size-1:0] s1_output46;
		wire [weight_size-1:0] s1_output47;
		wire [weight_size-1:0] s1_output48;
		wire [weight_size-1:0] s1_output49;
		wire [weight_size-1:0] s1_output50;
		wire [weight_size-1:0] s1_output51;
		wire [weight_size-1:0] s1_output52;
		wire [weight_size-1:0] s1_output53;
		wire [weight_size-1:0] s1_output54;
		wire [weight_size-1:0] s1_output55;
		wire [weight_size-1:0] s1_output56;
		wire [weight_size-1:0] s1_output57;
		wire [weight_size-1:0] s1_output58;
		wire [weight_size-1:0] s1_output59;
		wire [weight_size-1:0] s1_output60;
		wire [weight_size-1:0] s1_output61;
		wire [weight_size-1:0] s1_output62;
		wire [weight_size-1:0] s1_output63;
		wire [weight_size-1:0] s1_output64;
		wire [weight_size-1:0] s1_output65;
		wire [weight_size-1:0] s1_output66;
		wire [weight_size-1:0] s1_output67;
		wire [weight_size-1:0] s1_output68;
		wire [weight_size-1:0] s1_output69;
		wire [weight_size-1:0] s1_output70;
		wire [weight_size-1:0] s1_output71;
		wire [weight_size-1:0] s1_output72;
		wire [weight_size-1:0] s1_output73;
		wire [weight_size-1:0] s1_output74;
		wire [weight_size-1:0] s1_output75;
		wire [weight_size-1:0] s1_output76;
		wire [weight_size-1:0] s1_output77;
		wire [weight_size-1:0] s1_output78;
		wire [weight_size-1:0] s1_output79;
		wire [weight_size-1:0] s1_output80;
		wire [weight_size-1:0] s1_output81;
		wire [weight_size-1:0] s1_output82;
		wire [weight_size-1:0] s1_output83;
		wire [weight_size-1:0] s1_output84;
		wire [weight_size-1:0] s1_output85;
		wire [weight_size-1:0] s1_output86;
		wire [weight_size-1:0] s1_output87;
		wire [weight_size-1:0] s1_output88;
		wire [weight_size-1:0] s1_output89;
		wire [weight_size-1:0] s1_output90;
		wire [weight_size-1:0] s1_output91;
		wire [weight_size-1:0] s1_output92;
		wire [weight_size-1:0] s1_output93;
		wire [weight_size-1:0] s1_output94;
		wire [weight_size-1:0] s1_output95;
		wire [weight_size-1:0] s1_output96;
		wire [weight_size-1:0] s1_output97;
		wire [weight_size-1:0] s1_output98;
		wire [weight_size-1:0] s1_output99;
		wire [weight_size-1:0] s1_output100;
		
		wire [weight_size-1:0] s1_outpur1;
		wire [weight_size-1:0] s1_outpur2;
		wire [weight_size-1:0] s1_outpur3;
		wire [weight_size-1:0] s1_outpur4;
		wire [weight_size-1:0] s1_outpur5;
		wire [weight_size-1:0] s1_outpur6;
		wire [weight_size-1:0] s1_outpur7;
		wire [weight_size-1:0] s1_outpur8;
		wire [weight_size-1:0] s1_outpur9;
		wire [weight_size-1:0] s1_outpur10;
		wire [weight_size-1:0] s1_outpur11;
		wire [weight_size-1:0] s1_outpur12;
		wire [weight_size-1:0] s1_outpur13;
		wire [weight_size-1:0] s1_outpur14;
		wire [weight_size-1:0] s1_outpur15;
		wire [weight_size-1:0] s1_outpur16;
		wire [weight_size-1:0] s1_outpur17;
		wire [weight_size-1:0] s1_outpur18;
		wire [weight_size-1:0] s1_outpur19;
		wire [weight_size-1:0] s1_outpur20;
		wire [weight_size-1:0] s1_outpur21;
		wire [weight_size-1:0] s1_outpur22;
		wire [weight_size-1:0] s1_outpur23;
		wire [weight_size-1:0] s1_outpur24;
		wire [weight_size-1:0] s1_outpur25;
		wire [weight_size-1:0] s1_outpur26;
		wire [weight_size-1:0] s1_outpur27;
		wire [weight_size-1:0] s1_outpur28;
		wire [weight_size-1:0] s1_outpur29;
		wire [weight_size-1:0] s1_outpur30;
		wire [weight_size-1:0] s1_outpur31;
		wire [weight_size-1:0] s1_outpur32;
		wire [weight_size-1:0] s1_outpur33;
		wire [weight_size-1:0] s1_outpur34;
		wire [weight_size-1:0] s1_outpur35;
		wire [weight_size-1:0] s1_outpur36;
		wire [weight_size-1:0] s1_outpur37;
		wire [weight_size-1:0] s1_outpur38;
		wire [weight_size-1:0] s1_outpur39;
		wire [weight_size-1:0] s1_outpur40;
		wire [weight_size-1:0] s1_outpur41;
		wire [weight_size-1:0] s1_outpur42;
		wire [weight_size-1:0] s1_outpur43;
		wire [weight_size-1:0] s1_outpur44;
		wire [weight_size-1:0] s1_outpur45;
		wire [weight_size-1:0] s1_outpur46;
		wire [weight_size-1:0] s1_outpur47;
		wire [weight_size-1:0] s1_outpur48;
		wire [weight_size-1:0] s1_outpur49;
		wire [weight_size-1:0] s1_outpur50;
		wire [weight_size-1:0] s1_outpur51;
		wire [weight_size-1:0] s1_outpur52;
		wire [weight_size-1:0] s1_outpur53;
		wire [weight_size-1:0] s1_outpur54;
		wire [weight_size-1:0] s1_outpur55;
		wire [weight_size-1:0] s1_outpur56;
		wire [weight_size-1:0] s1_outpur57;
		wire [weight_size-1:0] s1_outpur58;
		wire [weight_size-1:0] s1_outpur59;
		wire [weight_size-1:0] s1_outpur60;
		wire [weight_size-1:0] s1_outpur61;
		wire [weight_size-1:0] s1_outpur62;
		wire [weight_size-1:0] s1_outpur63;
		wire [weight_size-1:0] s1_outpur64;
		wire [weight_size-1:0] s1_outpur65;
		wire [weight_size-1:0] s1_outpur66;
		wire [weight_size-1:0] s1_outpur67;
		wire [weight_size-1:0] s1_outpur68;
		wire [weight_size-1:0] s1_outpur69;
		wire [weight_size-1:0] s1_outpur70;
		wire [weight_size-1:0] s1_outpur71;
		wire [weight_size-1:0] s1_outpur72;
		wire [weight_size-1:0] s1_outpur73;
		wire [weight_size-1:0] s1_outpur74;
		wire [weight_size-1:0] s1_outpur75;
		wire [weight_size-1:0] s1_outpur76;
		wire [weight_size-1:0] s1_outpur77;
		wire [weight_size-1:0] s1_outpur78;
		wire [weight_size-1:0] s1_outpur79;
		wire [weight_size-1:0] s1_outpur80;
		wire [weight_size-1:0] s1_outpur81;
		wire [weight_size-1:0] s1_outpur82;
		wire [weight_size-1:0] s1_outpur83;
		wire [weight_size-1:0] s1_outpur84;
		wire [weight_size-1:0] s1_outpur85;
		wire [weight_size-1:0] s1_outpur86;
		wire [weight_size-1:0] s1_outpur87;
		wire [weight_size-1:0] s1_outpur88;
		wire [weight_size-1:0] s1_outpur89;
		wire [weight_size-1:0] s1_outpur90;
		wire [weight_size-1:0] s1_outpur91;
		wire [weight_size-1:0] s1_outpur92;
		wire [weight_size-1:0] s1_outpur93;
		wire [weight_size-1:0] s1_outpur94;
		wire [weight_size-1:0] s1_outpur95;
		wire [weight_size-1:0] s1_outpur96;
		wire [weight_size-1:0] s1_outpur97;
		wire [weight_size-1:0] s1_outpur98;
		wire [weight_size-1:0] s1_outpur99;
		wire [weight_size-1:0] s1_outpur100;
		
		wire [counter_size-1:0] s2_counter_out;
		wire [weight_size-1:0] s2_output;
		wire [accumulator_size-1:0] s2_output_e;
		
		
		
		
		nn_register_mux_100 stage_1(clk,weight1,weight2,weight3,weight4,weight5,weight6,weight7,
											weight8,weight9,weight10,weight11,weight12,weight13,weight14,
											weight15,weight16,weight17,weight18,weight19,weight20,weight21,
											weight22,weight23,weight24,weight25,weight26,weight27,weight28,
											weight29,weight30,weight31,weight32,weight33,weight34,weight35,
											weight36,weight37,weight38,weight39,weight40,weight41,weight42,
											weight43,weight44,weight45,weight46,weight47,weight48,weight49,
											weight50,weight51,weight52,weight53,weight54,weight55,weight56,
											weight57,weight58,weight59,weight60,weight61,weight62,weight63,
											weight64,weight65,weight66,weight67,weight68,weight69,weight70,
											weight71,weight72,weight73,weight74,weight75,weight76,weight77,
											weight78,weight79,weight80,weight81,weight82,weight83,weight84,
											weight85,weight86,weight87,weight88,weight89,weight90,weight91,
											weight92,weight93,weight94,weight95,weight96,weight97,weight98,
											weight99,bias, 
											cont_reset[0], cont_enable[0],in_vector,
											s1_outpur1,s1_outpur2,
											s1_outpur3,s1_outpur4,s1_outpur5,s1_outpur6,s1_outpur7,s1_outpur8,
											s1_outpur9,s1_outpur10,s1_outpur11,s1_outpur12,s1_outpur13,s1_outpur14,
											s1_outpur15,s1_outpur16,s1_outpur17,s1_outpur18,s1_outpur19,s1_outpur20,
											s1_outpur21,s1_outpur22,s1_outpur23,s1_outpur24,s1_outpur25,s1_outpur26,
											s1_outpur27,s1_outpur28,s1_outpur29,s1_outpur30,s1_outpur31,s1_outpur32,
											s1_outpur33,s1_outpur34,s1_outpur35,s1_outpur36,s1_outpur37,s1_outpur38,
											s1_outpur39,s1_outpur40,s1_outpur41,s1_outpur42,s1_outpur43,s1_outpur44,
											s1_outpur45,s1_outpur46,s1_outpur47,s1_outpur48,s1_outpur49,s1_outpur50,
											s1_outpur51,s1_outpur52,s1_outpur53,s1_outpur54,s1_outpur55,s1_outpur56,
											s1_outpur57,s1_outpur58,s1_outpur59,s1_outpur60,s1_outpur61,s1_outpur62,
											s1_outpur63,s1_outpur64,s1_outpur65,s1_outpur66,s1_outpur67,s1_outpur68,
											s1_outpur69,s1_outpur70,s1_outpur71,s1_outpur72,s1_outpur73,s1_outpur74,
											s1_outpur75,s1_outpur76,s1_outpur77,s1_outpur78,s1_outpur79,s1_outpur80,
											s1_outpur81,s1_outpur82,s1_outpur83,s1_outpur84,s1_outpur85,s1_outpur86,
											s1_outpur87,s1_outpur88,s1_outpur89,s1_outpur90,s1_outpur91,s1_outpur92,
											s1_outpur93,s1_outpur94,s1_outpur95,s1_outpur96,s1_outpur97,s1_outpur98,
											s1_outpur99,s1_outpur100,
											s1_output1,s1_output2,
											s1_output3,s1_output4,s1_output5,s1_output6,s1_output7,s1_output8,
											s1_output9,s1_output10,s1_output11,s1_output12,s1_output13,s1_output14,
											s1_output15,s1_output16,s1_output17,s1_output18,s1_output19,s1_output20,
											s1_output21,s1_output22,s1_output23,s1_output24,s1_output25,s1_output26,
											s1_output27,s1_output28,s1_output29,s1_output30,s1_output31,s1_output32,
											s1_output33,s1_output34,s1_output35,s1_output36,s1_output37,s1_output38,
											s1_output39,s1_output40,s1_output41,s1_output42,s1_output43,s1_output44,
											s1_output45,s1_output46,s1_output47,s1_output48,s1_output49,s1_output50,
											s1_output51,s1_output52,s1_output53,s1_output54,s1_output55,s1_output56,
											s1_output57,s1_output58,s1_output59,s1_output60,s1_output61,s1_output62,
											s1_output63,s1_output64,s1_output65,s1_output66,s1_output67,s1_output68,
											s1_output69,s1_output70,s1_output71,s1_output72,s1_output73,s1_output74,
											s1_output75,s1_output76,s1_output77,s1_output78,s1_output79,s1_output80,
											s1_output81,s1_output82,s1_output83,s1_output84,s1_output85,s1_output86,
											s1_output87,s1_output88,s1_output89,s1_output90,s1_output91,s1_output92,
											s1_output93,s1_output94,s1_output95,s1_output96,s1_output97,s1_output98,
											s1_output99,s1_output100);
		
		
		weight_update update1(~result_out[accumulator_size-1], expected,in_vector[0], s1_outpur1,weight1);
		weight_update update2(~result_out[accumulator_size-1], expected,in_vector[1], s1_outpur2,weight2);
		weight_update update3(~result_out[accumulator_size-1], expected,in_vector[2], s1_outpur3,weight3);
		weight_update update4(~result_out[accumulator_size-1], expected,in_vector[3], s1_outpur4,weight4);
		weight_update update5(~result_out[accumulator_size-1], expected,in_vector[4], s1_outpur5,weight5);
		weight_update update6(~result_out[accumulator_size-1], expected,in_vector[5], s1_outpur6,weight6);
		weight_update update7(~result_out[accumulator_size-1], expected,in_vector[6], s1_outpur7,weight7);
		weight_update update8(~result_out[accumulator_size-1], expected,in_vector[7], s1_outpur8,weight8);
		weight_update update9(~result_out[accumulator_size-1], expected,in_vector[8], s1_outpur9,weight9);
		weight_update update10(~result_out[accumulator_size-1], expected,in_vector[9], s1_outpur10,weight10);
		weight_update update11(~result_out[accumulator_size-1], expected,in_vector[10], s1_outpur11,weight11);
		weight_update update12(~result_out[accumulator_size-1], expected,in_vector[11], s1_outpur12,weight12);
		weight_update update13(~result_out[accumulator_size-1], expected,in_vector[12], s1_outpur13,weight13);
		weight_update update14(~result_out[accumulator_size-1], expected,in_vector[13], s1_outpur14,weight14);
		weight_update update15(~result_out[accumulator_size-1], expected,in_vector[14], s1_outpur15,weight15);
		weight_update update16(~result_out[accumulator_size-1], expected,in_vector[15], s1_outpur16,weight16);
		weight_update update17(~result_out[accumulator_size-1], expected,in_vector[16], s1_outpur17,weight17);
		weight_update update18(~result_out[accumulator_size-1], expected,in_vector[17], s1_outpur18,weight18);
		weight_update update19(~result_out[accumulator_size-1], expected,in_vector[18], s1_outpur19,weight19);
		weight_update update20(~result_out[accumulator_size-1], expected,in_vector[19], s1_outpur20,weight20);
		weight_update update21(~result_out[accumulator_size-1], expected,in_vector[20], s1_outpur21,weight21);
		weight_update update22(~result_out[accumulator_size-1], expected,in_vector[21], s1_outpur22,weight22);
		weight_update update23(~result_out[accumulator_size-1], expected,in_vector[22], s1_outpur23,weight23);
		weight_update update24(~result_out[accumulator_size-1], expected,in_vector[23], s1_outpur24,weight24);
		weight_update update25(~result_out[accumulator_size-1], expected,in_vector[24], s1_outpur25,weight25);
		weight_update update26(~result_out[accumulator_size-1], expected,in_vector[25], s1_outpur26,weight26);
		weight_update update27(~result_out[accumulator_size-1], expected,in_vector[26], s1_outpur27,weight27);
		weight_update update28(~result_out[accumulator_size-1], expected,in_vector[27], s1_outpur28,weight28);
		weight_update update29(~result_out[accumulator_size-1], expected,in_vector[28], s1_outpur29,weight29);
		weight_update update30(~result_out[accumulator_size-1], expected,in_vector[29], s1_outpur30,weight30);
		weight_update update31(~result_out[accumulator_size-1], expected,in_vector[30], s1_outpur31,weight31);
		weight_update update32(~result_out[accumulator_size-1], expected,in_vector[31], s1_outpur32,weight32);
		weight_update update33(~result_out[accumulator_size-1], expected,in_vector[32], s1_outpur33,weight33);
		weight_update update34(~result_out[accumulator_size-1], expected,in_vector[33], s1_outpur34,weight34);
		weight_update update35(~result_out[accumulator_size-1], expected,in_vector[34], s1_outpur35,weight35);
		weight_update update36(~result_out[accumulator_size-1], expected,in_vector[35], s1_outpur36,weight36);
		weight_update update37(~result_out[accumulator_size-1], expected,in_vector[36], s1_outpur37,weight37);
		weight_update update38(~result_out[accumulator_size-1], expected,in_vector[37], s1_outpur38,weight38);
		weight_update update39(~result_out[accumulator_size-1], expected,in_vector[38], s1_outpur39,weight39);
		weight_update update40(~result_out[accumulator_size-1], expected,in_vector[39], s1_outpur40,weight40);
		weight_update update41(~result_out[accumulator_size-1], expected,in_vector[40], s1_outpur41,weight41);
		weight_update update42(~result_out[accumulator_size-1], expected,in_vector[41], s1_outpur42,weight42);
		weight_update update43(~result_out[accumulator_size-1], expected,in_vector[42], s1_outpur43,weight43);
		weight_update update44(~result_out[accumulator_size-1], expected,in_vector[43], s1_outpur44,weight44);
		weight_update update45(~result_out[accumulator_size-1], expected,in_vector[44], s1_outpur45,weight45);
		weight_update update46(~result_out[accumulator_size-1], expected,in_vector[45], s1_outpur46,weight46);
		weight_update update47(~result_out[accumulator_size-1], expected,in_vector[46], s1_outpur47,weight47);
		weight_update update48(~result_out[accumulator_size-1], expected,in_vector[47], s1_outpur48,weight48);
		weight_update update49(~result_out[accumulator_size-1], expected,in_vector[48], s1_outpur49,weight49);
		weight_update update50(~result_out[accumulator_size-1], expected,in_vector[49], s1_outpur50,weight50);
		weight_update update51(~result_out[accumulator_size-1], expected,in_vector[50], s1_outpur51,weight51);
		weight_update update52(~result_out[accumulator_size-1], expected,in_vector[51], s1_outpur52,weight52);
		weight_update update53(~result_out[accumulator_size-1], expected,in_vector[52], s1_outpur53,weight53);
		weight_update update54(~result_out[accumulator_size-1], expected,in_vector[53], s1_outpur54,weight54);
		weight_update update55(~result_out[accumulator_size-1], expected,in_vector[54], s1_outpur55,weight55);
		weight_update update56(~result_out[accumulator_size-1], expected,in_vector[55], s1_outpur56,weight56);
		weight_update update57(~result_out[accumulator_size-1], expected,in_vector[56], s1_outpur57,weight57);
		weight_update update58(~result_out[accumulator_size-1], expected,in_vector[57], s1_outpur58,weight58);
		weight_update update59(~result_out[accumulator_size-1], expected,in_vector[58], s1_outpur59,weight59);
		weight_update update60(~result_out[accumulator_size-1], expected,in_vector[59], s1_outpur60,weight60);
		weight_update update61(~result_out[accumulator_size-1], expected,in_vector[60], s1_outpur61,weight61);
		weight_update update62(~result_out[accumulator_size-1], expected,in_vector[61], s1_outpur62,weight62);
		weight_update update63(~result_out[accumulator_size-1], expected,in_vector[62], s1_outpur63,weight63);
		weight_update update64(~result_out[accumulator_size-1], expected,in_vector[63], s1_outpur64,weight64);
		weight_update update65(~result_out[accumulator_size-1], expected,in_vector[64], s1_outpur65,weight65);
		weight_update update66(~result_out[accumulator_size-1], expected,in_vector[65], s1_outpur66,weight66);
		weight_update update67(~result_out[accumulator_size-1], expected,in_vector[66], s1_outpur67,weight67);
		weight_update update68(~result_out[accumulator_size-1], expected,in_vector[67], s1_outpur68,weight68);
		weight_update update69(~result_out[accumulator_size-1], expected,in_vector[68], s1_outpur69,weight69);
		weight_update update70(~result_out[accumulator_size-1], expected,in_vector[69], s1_outpur70,weight70);
		weight_update update71(~result_out[accumulator_size-1], expected,in_vector[70], s1_outpur71,weight71);
		weight_update update72(~result_out[accumulator_size-1], expected,in_vector[71], s1_outpur72,weight72);
		weight_update update73(~result_out[accumulator_size-1], expected,in_vector[72], s1_outpur73,weight73);
		weight_update update74(~result_out[accumulator_size-1], expected,in_vector[73], s1_outpur74,weight74);
		weight_update update75(~result_out[accumulator_size-1], expected,in_vector[74], s1_outpur75,weight75);
		weight_update update76(~result_out[accumulator_size-1], expected,in_vector[75], s1_outpur76,weight76);
		weight_update update77(~result_out[accumulator_size-1], expected,in_vector[76], s1_outpur77,weight77);
		weight_update update78(~result_out[accumulator_size-1], expected,in_vector[77], s1_outpur78,weight78);
		weight_update update79(~result_out[accumulator_size-1], expected,in_vector[78], s1_outpur79,weight79);
		weight_update update80(~result_out[accumulator_size-1], expected,in_vector[79], s1_outpur80,weight80);
		weight_update update81(~result_out[accumulator_size-1], expected,in_vector[80], s1_outpur81,weight81);
		weight_update update82(~result_out[accumulator_size-1], expected,in_vector[81], s1_outpur82,weight82);
		weight_update update83(~result_out[accumulator_size-1], expected,in_vector[82], s1_outpur83,weight83);
		weight_update update84(~result_out[accumulator_size-1], expected,in_vector[83], s1_outpur84,weight84);
		weight_update update85(~result_out[accumulator_size-1], expected,in_vector[84], s1_outpur85,weight85);
		weight_update update86(~result_out[accumulator_size-1], expected,in_vector[85], s1_outpur86,weight86);
		weight_update update87(~result_out[accumulator_size-1], expected,in_vector[86], s1_outpur87,weight87);
		weight_update update88(~result_out[accumulator_size-1], expected,in_vector[87], s1_outpur88,weight88);
		weight_update update89(~result_out[accumulator_size-1], expected,in_vector[88], s1_outpur89,weight89);
		weight_update update90(~result_out[accumulator_size-1], expected,in_vector[89], s1_outpur90,weight90);
		weight_update update91(~result_out[accumulator_size-1], expected,in_vector[90], s1_outpur91,weight91);
		weight_update update92(~result_out[accumulator_size-1], expected,in_vector[91], s1_outpur92,weight92);
		weight_update update93(~result_out[accumulator_size-1], expected,in_vector[92], s1_outpur93,weight93);
		weight_update update94(~result_out[accumulator_size-1], expected,in_vector[93], s1_outpur94,weight94);
		weight_update update95(~result_out[accumulator_size-1], expected,in_vector[94], s1_outpur95,weight95);
		weight_update update96(~result_out[accumulator_size-1], expected,in_vector[95], s1_outpur96,weight96);
		weight_update update97(~result_out[accumulator_size-1], expected,in_vector[96], s1_outpur97,weight97);
		weight_update update98(~result_out[accumulator_size-1], expected,in_vector[97], s1_outpur98,weight98);
		weight_update update99(~result_out[accumulator_size-1], expected,in_vector[98], s1_outpur99,weight99);
		bias_update b_update(~result_out[accumulator_size-1], expected, s1_outpur100, bias);
		
		
		
		
		
		
		nn_mux_100_1_8 stage_2_mux(s1_output1,s1_output2,s1_output3,s1_output4,s1_output5,s1_output6,s1_output7,s1_output8,s1_output9,s1_output10,s1_output11,s1_output12,s1_output13,s1_output14,s1_output15,s1_output16,s1_output17,s1_output18,s1_output19,s1_output20,s1_output21,s1_output22,s1_output23,s1_output24,s1_output25,s1_output26,s1_output27,s1_output28,s1_output29,s1_output30,s1_output31,s1_output32,s1_output33,s1_output34,s1_output35,s1_output36,s1_output37,s1_output38,s1_output39,s1_output40,s1_output41,s1_output42,s1_output43,s1_output44,s1_output45,s1_output46,s1_output47,s1_output48,s1_output49,s1_output50,s1_output51,s1_output52,s1_output53,s1_output54,s1_output55,s1_output56,s1_output57,s1_output58,s1_output59,s1_output60,s1_output61,s1_output62,s1_output63,s1_output64,s1_output65,s1_output66,s1_output67,s1_output68,s1_output69,s1_output70,s1_output71,s1_output72,s1_output73,s1_output74,s1_output75,s1_output76,s1_output77,s1_output78,s1_output79,s1_output80,s1_output81,s1_output82,s1_output83,s1_output84,s1_output85,s1_output86,s1_output87,s1_output88,s1_output89,s1_output90,s1_output91,s1_output92,s1_output93,s1_output94,s1_output95,s1_output96,s1_output97,s1_output98,s1_output99,s1_output100,s2_counter_out,s2_output);
		nn_counter stage_2_counter(clk, cont_enable[1], cont_reset[1], s2_counter_out);
		assign s2_output_e[weight_size-1:0] = s2_output;
		assign s2_output_e[accumulator_size-1:weight_size] = {s2_output[7],s2_output[7],s2_output[7],s2_output[7],s2_output[7],s2_output[7],s2_output[7],s2_output[7]};
		nn_accumulator stage_3(clk, cont_enable[2], cont_reset[2], s2_output_e, result_out);
		
	
		assign nn_out = ~result_out[accumulator_size-1];


endmodule
