//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    17:51:27 03/01/2008 
// Design Name: 
// Module Name:    weight_update 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module weight_update(nn_out, expected, X, w_old, w_new);
    input nn_out;
    input expected;
    input X;
    input [7:0] w_old;
    output [7:0] w_new;

 	 wire cout;
	 wire [7:0] diff;
	 wire [7:0] mux_out;
    error_diff errorDiff(nn_out, expected, diff);
    nn_mux_2_1_8 mux(diff, 8'b00000000, X, mux_out); 
	 full_adder8 adder(mux_out, w_old, 1'b0, w_new, cout);
endmodule
