//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    10:23:34 03/19/2008 
// Design Name: 
// Module Name:    summer 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module summer(clk, en_reg, shift, en_acc, reset, in, out, out_sum);

	parameter bus_width = 6'd16;
	input clk;
	input en_reg;
	input shift;
	input en_acc;
	input reset;
	input [31:0] in;
	output out;
	output [15:0] out_sum;
	
	wire out_shift;
	wire [bus_width-1:0] out_accumulator; 
	
	
	shift_ff32 shift_reg(clk, 1'b0, in, shift, en_reg, reset, out_shift);
	accumulator16 shift_accum(clk, en_acc, reset, out_shift, out_accumulator);
	Comparator comp_subract(out_accumulator, out);
	
	assign out_sum = out_accumulator;

endmodule
