//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    12:57:10 02/26/2008 
// Design Name: 
// Module Name:    nn_accumulator 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module accumulator16(clk, enable, reset, in, out);
   
	parameter bus_width = 6'd16;
	parameter zero16 = 16'd0;
	
	input clk;
   input enable;
   input reset;
	input in;
   output [bus_width-1:0] out;
	
	wire [bus_width-1:0] adder_out;
	wire [bus_width-1:0] reg_out;
	wire [bus_width-1:0] in_one;
	wire nothing;
	
	assign in_one = zero16;
	
	register16 reg_counter(clk, adder_out, reset, enable, reg_out);
	full_adder16 adder_counter(reg_out, in_one, in, adder_out, nothing);
	
	assign out = reg_out;

endmodule
