library verilog;
use verilog.vl_types.all;
entity nn_testing is
    generic(
        weight_size     : integer := 8;
        input_size      : integer := 99;
        counter_size    : integer := 7;
        accumulator_size: integer := 16
    );
    port(
        clk             : in     vl_logic;
        expected        : in     vl_logic;
        cont_enable     : in     vl_logic_vector(2 downto 0);
        cont_reset      : in     vl_logic_vector(2 downto 0);
        in_vector       : in     vl_logic_vector;
        nn_out          : out    vl_logic
    );
end nn_testing;
