library verilog;
use verilog.vl_types.all;
entity sum_control is
    generic(
        N               : integer := 32;
        INCR            : integer := 1;
        st_reset        : integer := 0;
        st_load         : integer := 1;
        st_add          : integer := 2;
        st_shift        : integer := 3;
        st_done         : integer := 4
    );
    port(
        clk             : in     vl_logic;
        reset           : in     vl_logic;
        go              : in     vl_logic;
        en_reg          : out    vl_logic;
        shift           : out    vl_logic;
        en_acc          : out    vl_logic;
        reset_sum       : out    vl_logic;
        done            : out    vl_logic
    );
end sum_control;
