//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    16:13:23 03/22/2008 
// Design Name: 
// Module Name:    reduction_unit 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module reduction_unit(clk, reset, go, in_1, in_2, in_3, in_4, in_5, in_6, in_7, in_8, in_9, done, out_1, out_2, out_3, out_4, out_5, out_6, out_7, out_8, out_9);
    input clk;
    input reset;
    input go;
    input [31:0] in_1;
    input [31:0] in_2;
	 input [31:0] in_3;
	 input [31:0] in_4;
	 input [31:0] in_5;
	 input [31:0] in_6;
	 input [31:0] in_7;
	 input [31:0] in_8;
	 input [31:0] in_9;
	 
	 output done;
    
	 output out_1;
	 output out_2;
	 output out_3;
	 output out_4;
	 output out_5;
	 output out_6;
	 output out_7;
	 output out_8;
	 output out_9;
	 
	 
	 wire en_reg, shift, en_acc, reset_sum;
	 
	 wire [15:0] out_sum_1;
	 wire [15:0] out_sum_2;
	 wire [15:0] out_sum_3;
	 wire [15:0] out_sum_4;
	 wire [15:0] out_sum_5;
	 wire [15:0] out_sum_6;
	 wire [15:0] out_sum_7;
	 wire [15:0] out_sum_8;
	 wire [15:0] out_sum_9;
	
	 
	 //The controller
	 sum_control controller(clk, reset, go, en_reg, shift, en_acc, reset_sum, done);
	 
	 //The summer modules
	 summer sum_mod_1(clk, en_reg, shift, en_acc, reset_sum, in_1, out_1, out_sum_1);
	 summer sum_mod_2(clk, en_reg, shift, en_acc, reset_sum, in_2, out_2, out_sum_2);
	 summer sum_mod_3(clk, en_reg, shift, en_acc, reset_sum, in_3, out_3, out_sum_3);
	 summer sum_mod_4(clk, en_reg, shift, en_acc, reset_sum, in_4, out_4, out_sum_4);
	 summer sum_mod_5(clk, en_reg, shift, en_acc, reset_sum, in_5, out_5, out_sum_5);
	 summer sum_mod_6(clk, en_reg, shift, en_acc, reset_sum, in_6, out_6, out_sum_6);
	 summer sum_mod_7(clk, en_reg, shift, en_acc, reset_sum, in_7, out_7, out_sum_7);
	 summer sum_mod_8(clk, en_reg, shift, en_acc, reset_sum, in_8, out_8, out_sum_8);
	 summer sum_mod_9(clk, en_reg, shift, en_acc, reset_sum, in_9, out_9, out_sum_9);
	 
	 
endmodule
