#include "xparameters.h"
#include "mb_interface.h"
#include "xbasic_types.h"

void send_image(int,int,int,int);
int get_result();
void print_result(int);
void training();
void receive_small_image();
void receive_big_image();


int main(void)
{
	int i = 0;
	
	
	//ru_testing();
	
	training();
	while(1)
		receive_big_image();
	
	/*while(i++<5)
	{
		receive_small_image();
	}*/
	
}

void send_image(int word1, int word2, int word3, int word4)
{
	
	nputfsl(word1,0);
   //xil_printf("%d; ",data_in);
	
	nputfsl(word2,0);
   //xil_printf("%d; ",data_in);
	
	nputfsl(word3,0);
   //xil_printf("%d; ",data_in);
	
	nputfsl(word4,0);
   //xil_printf("%d; ",data_in);
	
	return;
}

int get_result()
{
	int result;
	getfsl(result,1);
	return result;
}

void print_result(int input)
{	
	int temp;
	int detected = 0;
	
	temp = input & 0x1;
	if(temp !=0)
	{	
		xil_printf("A is detected.");
		detected = 1;
	}
		
	temp = input & 0x2;
	if(temp !=0)
	{
		xil_printf("B is detected.");
		detected = 1;
	}
	
	temp = input & 0x4;
	if(temp !=0)
	{	
		xil_printf("C is detected.");
		detected = 1;
	}
	
	temp = input & 0x8;
	if(temp !=0)
	{	
		xil_printf("D is detected.");
		detected = 1;
	}
	
	temp = input & 0x10;
	if(temp !=0) 
	{
		xil_printf("E is detected.");
		detected = 1;
	}
	
	temp = input & 0x20;
	if(temp !=0) 
	{
		xil_printf("F is detected.");
		detected = 1;
	}
	
	temp = input & 0x40;
	if(temp !=0) 
	{
		xil_printf("G is detected.");
		detected = 1;
	}
	
	temp = input & 0x80;
	if(temp !=0) 
	{
		xil_printf("H is detected.");
		detected = 1;
	}
	
	temp = input & 0x100;
	if(temp !=0) 
	{
		xil_printf("I is detected.");
		detected = 1;
	}
	
	temp = input & 0x200;
	if(temp !=0) 
	{
		xil_printf("J is detected.");
		detected = 1;
	}
	
   if(detected == 0)
		xil_printf("Nothing is detected.");
		
	xil_printf("\n\r");
   		
	return;
} 


void receive_small_image()
{
	Xuint8 s = 0;
	Xuint32 data_1 = 0;
	Xuint32 data_2 = 0;
	Xuint32 data_3 = 0;
	Xuint32 data_4 = 0;
	int data_out = 5;
	
	int i = 0;
   
   for (i=1;i<=4;i++)
	{	
		s = XUartLite_RecvByte(0x40600000);
		data_1 = data_1 | (0x000000ff & s);
		if(i!=4) data_1 = data_1 << 8;
	}
	//xil_printf("%x\n\r",data_1);
	
	for (i=1;i<=4;i++)
	{	
		s = XUartLite_RecvByte(0x40600000);
		data_2 = data_2 | (0x000000ff & s);
		if(i!=4) data_2 = data_2 << 8;
	}
	//xil_printf("%x\n\r",data_2);
	
	for (i=1;i<=4;i++)
	{	
		s = XUartLite_RecvByte(0x40600000);
		data_3 = data_3 | (0x000000ff & s);
		if(i!=4) data_3 = data_3 << 8;
	}
	//xil_printf("%x\n\r",data_3);
	
	for (i=1;i<=4;i++)
	{	
		s = XUartLite_RecvByte(0x40600000);
		data_4 = data_4 | (0x000000ff & s);
		if(i!=4) data_4 = data_4 << 8;
	}
	//xil_printf("%x\n\r",data_4);
	
	send_image(data_1,data_2,data_3,data_4);
	data_out = get_result();
	data_out = get_result();
	print_result(data_out);
}

void receive_big_image()
{
	Xuint8 s = 0;
	Xuint32 data = {0};
	int result[11]={0};
	int data_out = 5;
	
	int i = 0;
	int j = 0;
	int k =0;
	
	int combine_1 = 0;
	int combine_2 = 0;
	int combine_3 = 0;
	int combine_4 = 0;
	int temp = 0;
	int touch = 0;
	
	xil_printf("Waiting for image\n\r");
	for (k=0;k<11;k++)
	{
		for (i=0;i<288;i++)
		{
			for (j=1;j<=4;j++)
			{	
				s = XUartLite_RecvByte(0x40600000);
				if(touch == 0) 
				{
					xil_printf("Receiving and Reducing Image\n\r");
					touch = 1;
				}
				data = data | (0x000000ff & s);
				if(j!=4) data = data << 8;
			}
			nputfsl(data,2);
			data = 0;
		}
		getfsl(result[k],3);
		//xil_printf("%x\n\r",result[k]);
	}
	touch = 0;
	xil_printf("Image Reduced\n\r");
	combine_4 = combine_4 | (result[10]);
	temp = result[9] <<9;
	combine_4 = combine_4 | temp;
	temp = result[8] <<18;
	combine_4 = combine_4 | temp;
	temp = result[7] & 0x1f;
	temp = temp <<27;
	combine_4 = combine_4 | temp;
	//xil_printf("%x\n\r",combine_4);
	
	temp = result[7] >>5;
	combine_3 = combine_3 | temp;
	temp = result[6] <<4;
	combine_3 = combine_3 | temp;
	temp = result[5] <<13;
	combine_3 = combine_3 | temp;
	temp = result[4] <<22;
	combine_3 = combine_3 | temp;
	temp = result[3] & 0x1;
	temp = temp <<31;
	combine_3 = combine_3 | temp;
	//xil_printf("%x\n\r",combine_3);
	
	temp = result[3] >> 1;
	combine_2 = combine_2 | temp;
	temp = result[2] <<8;
	combine_2 = combine_2 | temp;
	temp = result[1] <<17;
	combine_2 = combine_2 | temp;
	temp = result[0] <<26;
	combine_2 = combine_2 | temp;
	//xil_printf("%x\n\r",combine_2);
	
	combine_1 = result[0] >> 6;
	combine_1 = combine_1 | 0x80000000;
	//xil_printf("%x\n\r",combine_1);
	
   xil_printf("Detecting image\n\r");
	send_image(combine_1,combine_2,combine_3,combine_4);
	data_out = get_result();
	data_out = get_result();
	print_result(data_out);
}

void training()
{
	int epoch = 1000;
	int data_out = 5;
	int i =1;
	
	xil_printf("Started training!!!!\n\r");
	
	for( i=1;i<=epoch;i++)
	{
	
		/*A training*/
		send_image(0x40000004,0x00fcfe7f,0x001fcfe7,0xf3f9fcfe);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x40000007,0xbfcfc7e9,0xe6f733d8,0x01f1f8fe);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x40000006,0x1f673bbc,0x9e4fa001,0xe3f9fcfe);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x40000007,0x1f0f93d9,0xcee037db,0xe9f0fcfe);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x40000004,0x0cf27d7e,0x3f804707,0xf3f9fcfe);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x40000006,0x1f273b9c,0xde602783,0xe3f9fcfe);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x40000006,0x7f1f2f93,0xddee61b0,0x0bf5f8fe);
		data_out = get_result();
		data_out = get_result();
		
		/*B training*/
		send_image(0x20000000,0x0df67b01,0x806f97eb,0xf5f2f101);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x20000000,0x05f8fe7f,0x3f9f0017,0xe3f9fc00);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x20000000,0x0de0fc7f,0x3f102197,0xe3f9fc00);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x20000000,0x0df0fe7f,0x3e000fc7,0xf3f9f801);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x20000000,0x0dc0fe7f,0x3f9f0007,0xe3f9f003);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x20000000,0x01fcfe7f,0x001fcfc7,0xf3f9fc00);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x20000000,0x01fcfe7f,0x0e002fc7,0xf3f9fc00);
		data_out = get_result();
		data_out = get_result();
		
		/*C training*/
		send_image(0x10000006,0x027e7f7f,0xbfdfeff3,0xfcff0fe0);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x10000006,0x06787f3f,0xbfdfeff3,0xfdfe03c7);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x10000006,0x06787e7f,0xbfdfeff7,0xfbfcfe00);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x10000004,0x04f8fe7f,0x3fdfeff7,0xfbf0f801);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x10000006,0x02787f3f,0xbfdfeff7,0xfbfc7f00);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x10000004,0x02fe7f3f,0xbfdfeff7,0xfbfdfe00);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x10000000,0x01feff7f,0xbfdfeff7,0xfbfdfe00);
		data_out = get_result();
		data_out = get_result();
		
		/*D training*/
		send_image(0x08000000,0x1dc6f97e,0x3f1fcfe7,0xf3f9fc00);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x08000005,0xfc1f63bc,0xdf2793c9,0xecc4063f);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x08000000,0x05f0fc7f,0x3f9fcfe7,0xf3f1e203);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x08000000,0x0de2fd7e,0x3f1fcfc7,0xe3e5c60f);
		data_out = get_result();
		data_out = get_result();
		
		
		send_image(0x08000000,0x0de0fe7f,0x3f9fcfe7,0xe3c58e1f);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x08000000,0x05fafc7e,0x3f9fcfe7,0xf1f8fc00);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x08000000,0xfc1ee37c,0x3f1fcfe7,0xe3c5063f);
		data_out = get_result();
		data_out = get_result();
		
		/*E training*/
		send_image(0x04000000,0x01f8ff7f,0xbfdfe007,0x8bfdfe01);
		data_out = get_result();
		data_out = get_result();
		
		
		send_image(0x04000000,0x05feff7f,0x801f8ff7,0xfbfdfe01);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x04000000,0x01feff70,0x801feff7,0xfbfdfe00);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x04000000,0x3d80ff7f,0xbfc00fc7,0xfbfdfe00);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x04000000,0x01feff7f,0xbf402ff7,0xfbfdfe00);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x04000000,0x0182ff7f,0x8fc00f87,0xfbfdfe00);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x04000000,0x01feff7f,0x80426ff7,0xfbfdfe00);
		data_out = get_result();
		data_out = get_result();
		
		/*F training*/
		send_image(0x02000007,0x021c7f3f,0x81dfeff7,0xfbfdfeff);
		data_out = get_result();
		data_out = get_result();
		
		
		send_image(0x02000000,0x01feff7f,0x83d82ff7,0xfbfdfeff);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x02000000,0x01feff7f,0xbfdfe0f7,0xfbfdfeff);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x02000000,0x00fcff7f,0xbfc000f7,0xfbfdfeff);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x02000000,0x01f2ff7f,0x804fe7fb,0xfdfeff7f);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x02000004,0x00feff7f,0xbfc02ff7,0xfbfdfeff);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x02000000,0x01feff00,0x3fdfeff7,0xfbfdfeff);
		data_out = get_result();
		data_out = get_result();
		
		
		/*G training*/
		send_image(0x01000004,0x0ce6f97f,0xbfdc0fe7,0xf1f8f901);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x01000000,0x0df2ff7f,0xbfdfef07,0xe3f8f801);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x01000000,0x1de6fb7c,0xbedfef87,0xe9f4fb01);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x01000004,0x00feff7f,0xbfd80fe7,0xf3f8fc00);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x01000004,0x06787f7f,0xbfdfe703,0x04f603c3);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x01000000,0x0df2ff7f,0xbfdfef07,0xe3f8f801);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x01000006,0x043eff7f,0xbfdc0e07,0xebf4fb01);
		data_out = get_result();
		data_out = get_result();
		
		/*H training*/
		send_image(0x00800003,0xf9fcfe7f,0x001fcfe7,0xf3f9fcfe);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00800003,0xf9fcfe7f,0x00180fe7,0xf3f9fcfc);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00800003,0xf9fcfe7f,0x3f800fe7,0xf3f9f8fc);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00800003,0xf9fcfe7f,0x0001cfe7,0xf3f9f8fc);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00800003,0xf9fcfe7f,0x3f800007,0xf3f9fcfe);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00800003,0xf9fcfe7f,0x3f9c4007,0xf3f9fcfe);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00800003,0xf5f8fc3e,0x0f8007e7,0xf3f9fcfe);
		data_out = get_result();
		data_out = get_result();
		
		/*I training*/
		send_image(0x00400007,0xdfeff7fb,0xfdfeff7f,0xbfdfeff7);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00400000,0x039fdfef,0xf7fbfdfe,0xff7fbe00);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00400000,0x03dfeff7,0xf3f9fcfe,0xff7fbe01);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00400000,0x0b81cff7,0xfbfdfeff,0x7f3fb801);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00400000,0x03eff7fb,0xfdfeff7f,0xbfdfee00);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00400007,0xbfdfeff7,0xfbfdfeff,0x7fbfdfef);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00400007,0x7fbfdfef,0xe7f3f9fc,0xfe7f3f9f);
		data_out = get_result();
		data_out = get_result();
		
		/*J training*/
		send_image(0x00200007,0xc3fdfeff,0x7fbfdfe7,0xf3f1f201);
		data_out = get_result();
		data_out = get_result();
		
		
		send_image(0x00200007,0x83fbfdfe,0xff3f9fc9,0xe4fa7980);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00200007,0xbfdfeff7,0xfbfdfef7,0x7bbc9e0f);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00200000,0x07cff7f9,0xfcff7fbf,0xddee6787);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00200007,0x83f7f9fc,0xfe7f3f9b,0xdcce078f);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00200007,0xeff7fbfd,0xfeff7fbb,0xddce0f8f);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00200000,0x07eff7fb,0xfcfe7f77,0xb9dc4f0f);
		data_out = get_result();
		data_out = get_result();
		
		send_image(0x00200000,0x03fdfeff,0x7fbfdfef,0xf3f8fd00);
	data_out = get_result();
	data_out = get_result();


	}
	
	xil_printf("End of training!!!!\n\r");
	
}

