`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    16:17:28 03/01/2008 
// Design Name: 
// Module Name:    xil_adder_v1_00_a 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module xil_adder(Clk,Reset,FSL_S_CLK,FSL_S_READ,FSL_S_DATA,FSL_S_CONTROL,FSL_S_EXISTS,FSL_M_CLK,FSL_M_WRITE,FSL_M_DATA,FSL_M_CONTROL,FSL_M_FULL);
parameter C_DWIDTH = 6'd32;
 
    /*Global signals*/
    input Clk; 
    input Reset; 
	 
    /*Slave FSL Signals*/
    output FSL_S_CLK;
    output FSL_S_READ;
    input [C_DWIDTH-1:0] FSL_S_DATA;
    input FSL_S_CONTROL;
    input FSL_S_EXISTS;

    /* Master FSL Signals*/
    output FSL_M_CLK;
    output FSL_M_WRITE;
    output [C_DWIDTH-1:0] FSL_M_DATA ;
    output FSL_M_CONTROL;
    input FSL_M_FULL; 
	 
	

	 full_adder_16_core core(Clk,Reset,FSL_S_DATA,FSL_S_EXISTS,FSL_S_READ,FSL_M_DATA,FSL_M_FULL,FSL_M_WRITE);


endmodule
