//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    17:48:36 03/01/2008 
// Design Name: 
// Module Name:    full_adder8 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module full_adder8(X, Y, CIN, SUM, COUT);
    input [7:0] X;
    input [7:0] Y;
    input CIN;
    output [7:0] SUM;
    output COUT;

	 wire [6:0] connect;
	 
	 full_adder adder0(X[0], Y[0], CIN, SUM[0], connect[0]);
	 full_adder adder1(X[1], Y[1], connect[0], SUM[1], connect[1]);
	 full_adder adder2(X[2], Y[2], connect[1], SUM[2], connect[2]);
	 full_adder adder3(X[3], Y[3], connect[2], SUM[3], connect[3]);
	 full_adder adder4(X[4], Y[4], connect[3], SUM[4], connect[4]);
	 full_adder adder5(X[5], Y[5], connect[4], SUM[5], connect[5]);
	 full_adder adder6(X[6], Y[6], connect[5], SUM[6], connect[6]);
	 full_adder adder15(X[7], Y[7], connect[6], SUM[7], COUT);

endmodule
