function reduce_image(filename)

%factor
factor = 32;

%input size
i_width = 9*factor;
i_height = 11*factor;

%target size
t_width = 9;
t_height = 11;

t_matrix = zeros(t_height,t_width);
t_sum = 0;
t_calc = zeros(factor,factor);

image = imread(filename);
i_matrix = image;

for i=1:factor:i_height
    for j=1:factor:i_width
        t_calc = i_matrix(i:i+factor-1,j:j+factor-1);
        t_sum = sum(sum(t_calc));
        if(t_sum <= 1014)
            t_matrix(ceil(i/factor),ceil(j/factor)) = 0;
        else
            t_matrix(ceil(i/factor),ceil(j/factor)) = 1;
        end
    end
end

imwrite(t_matrix,strcat('small_',filename));